from simtk.openmm.app import *
from simtk.openmm import *
from simtk.unit import *
from sys import stdout

plats = ['CUDA', 'CPU', 'Reference']

print "************TEST fail2-a******************"
pdb = PDBFile('fail2.pdb')
f = open("fail2-a.xml", "r").read()
system = XmlSerializer.deserialize(f)

for w in plats:
    pltfrm = Platform.getPlatformByName(w)
    integrator = LangevinIntegrator(300*kelvin, 1/picosecond, 0.002*picoseconds)
    context = Context(system,integrator,pltfrm)
    context.setPositions(pdb.positions)
    state = context.getState(getEnergy=True, getForces=True)
    potential = state.getPotentialEnergy()
    forces = state.getForces()
    
    platform = Platform.getName(context.getPlatform())
    print platform, potential
    print platform, forces
    
    del context, platform, pltfrm, integrator
    
del system, f, pdb

print "************TEST fail2-b******************"
pdb = PDBFile('fail2.pdb')
f = open("fail2-b.xml", "r").read()
system = XmlSerializer.deserialize(f)

for w in plats:
    pltfrm = Platform.getPlatformByName(w)
    integrator = LangevinIntegrator(300*kelvin, 1/picosecond, 0.002*picoseconds)
    context = Context(system,integrator,pltfrm)
    context.setPositions(pdb.positions)
    state = context.getState(getEnergy=True, getForces=True)
    potential = state.getPotentialEnergy()
    forces = state.getForces()
    
    platform = Platform.getName(context.getPlatform())
    print platform, potential
    print platform, forces
    
    del context, platform, pltfrm, integrator
    
del system, f, pdb

print "************TEST fail2-a+b******************"
pdb = PDBFile('fail2.pdb')
f = open("fail2.xml", "r").read()
system = XmlSerializer.deserialize(f)

for w in plats:
    pltfrm = Platform.getPlatformByName(w)
    integrator = LangevinIntegrator(300*kelvin, 1/picosecond, 0.002*picoseconds)
    context = Context(system,integrator,pltfrm)
    context.setPositions(pdb.positions)
    state = context.getState(getEnergy=True, getForces=True)
    potential = state.getPotentialEnergy()
    forces = state.getForces()
    
    platform = Platform.getName(context.getPlatform())
    print platform, potential
    print platform, forces
    
    del context, platform, pltfrm, integrator
    
del system, f, pdb

